<?php

// 2004-05-19 DSC

require_once("ECS/utils.php");

ECS_OpenCoreDB();

$html;
$mode;
$user = getenv("REMOTE_USER");


if(trim($user) == "")
{
  $html .= ASPAM_invalidUser();
}
else if($_POST['sub'] == 'submit')
{
  $html .= ASPAM_submit();
}
else
{
  $html .= ASPAM_default();
}

// Is user in the systems group?
function ASPAM_isUber($user)
{
  $uber = false;
  $sql = "SELECT * FROM STAFF WHERE Status='sys' AND Groupx='systems' AND email='" . $user . "'";
  $rs = ECS_query($sql);
  if(ECS_fetch_array($rs))
  {
    $uber = true;
  }

  return $uber;
}


function ASPAM_helpdesk()
{
  return '<a href="mailto:helpdesk@ecs.soton.ac.uk">helpdesk@ecs.soton.ac.uk</a>';
}

function ASPAM_invalidUser()
{
  return 'Error: invalid ECS username, please contact ' . ASPAM_helpdesk() . '.';
}

function ASPAM_submit()
{
  $user = getenv("REMOTE_USER");
  $uber = ASPAM_isUber($user);
  $threshold = 7;
  $enabled = 0;

  if(isset($_POST['email']) && $uber)
  {
    $user = $_POST['email'];
  }

  $html = '<p>';

  if(isset($_POST['enabled']) && $_POST['enabled'] == 1)
  {
    $enabled = 1;
  }

  $threshold = $_POST['spam_setting'];
  if($threshold < 5 || $threshold > 10)
  {
    // Should never happen
    $enabled = 0;
    $html .= "Error: spam threshold setting outside of safe bounds, automatic spam deletion disabled to be safe.</p><p>";
  }

  $sql = "SELECT * FROM Spam_threshold WHERE username='" . $user . "'";
  $rs = ECS_query($sql);
  if(ECS_fetch_array($rs))
  {
    $sql = "UPDATE Spam_threshold SET spam_threshold=" . $threshold . ", enabled=" . $enabled . " WHERE username='" . $user . "'";
  }
  else // New entry
  {
    $sql = "INSERT INTO Spam_threshold (username, spam_threshold, enabled) "
         . "VALUES ('" . $user . "'," . $threshold . "," . $enabled . ")";
  }

  $aspamhome = '<p><a href="index.php">Back to spam deletion settings</a></p>';
  $query = ECS_query($sql);
  if($query != FALSE)
  {
    if($enabled == 0)
    {
      $html .= 'Automatic spam deletion has been disabled for email ' . $user . '.<br/><br/>Mail tagged as spam will be delivered to your mailbox.';
    }
    else
    {
      $html .= 'Automatic spam deletion has been enabled for email ' . $user . '.<br/><br/>All mail with a spam score of ' . $threshold . ' or greater will automatically be deleted.';
    }

    $html .= '<p><b>Please note</b>: Your new settings may take up to about an hour to start working.</p>';
  }
  else
  {
    $html .= 'Error: A problem occured while trying to save your settings to the database.  Please press the back button to try again, or contact ' . ASPAM_helpdesk() . ' if the problem persists.';
  }

  $html .= '</p>';
  $html .= $aspamhome;

  return $html;
}



function ASPAM_default()
{
  $html .= '<h1>Automatic Spam Deletion</h1>';

  $user = getenv("REMOTE_USER");
  $uber = ASPAM_isUber($user);

  if($uber)
  {
    if(isset($_POST['email']) && trim($_POST['email']) != '')
    {
      $user = trim($_POST['email']);
    }

    $html .= '<h2>Systems User</h2>';
    $html .= '<p>Use the text box below to set up automatic spam deletion for other users or email addresses:</p>';
    $html .= '<p><form action="index.php" method="post">';
    $html .= '<input type="text" name="email" value="' . $user . '" /><br/>';
    $html .= '<input type="submit" name="sub" value="Change user" /></form></p>';
  }

  $threshold = 7;
  $enabled = 0;

  $sql = "SELECT * FROM Spam_threshold WHERE username='" . $user . "'";
  $rs = ECS_query($sql);
  if($row = ECS_fetch_array($rs))
  {
    $threshold = $row['spam_threshold'];
    $enabled = $row['enabled'];
  }

  $selection = array(
                  10 => "10 (Only delete definite spam)",
                  9 => "9",
                  8 => "8",
                  7 => "7 (Default: ok for most people)",
                  6 => "6",
                  5 => "5 (Aggressive: delete anything that might be spam)");

  $selected = array();
  foreach(array_keys($selection) as $key)
  {
    $selected[$key] = "";
  }

  $selected[$threshold] = "checked";
  
  $enablechecked = "";
  if($enabled == 1)
  {
    $enablechecked = "checked";
  }


  $blurb = '
<p>
You can use this web page to instruct the ECS mail system to automatically
delete any spam e-mail addressed to you.
If you enable this service, any e-mail which our spam detectors classify as
spam will be thrown away and will not be delivered to you.
</p><p>
Note that while our spam detectors have proved very reliable, they will
very occasionally misclassify a non-spam e-mail as spam.
</p><p>
To make it less likely that a non-spam e-mail is thrown away, you can
choose a spam threshold at which the system will throw away spam. There are
threshold scores of five to ten. Five indicates that the spam detectors think the
e-mail is very likely to be spam. Ten indicates that the spam detectors
think the e-mail is definitely spam.
</p><p>
We strongly suggest that you choose a threshold of seven if a very occasional
misclassified e-mail is acceptable and a threshold of ten if it is
totally unacceptable.
</p><p>
If after enabling this service, you still receive a lot of e-mail with the
{SPAM?} subject line tag, please contact a member of the systems staff
as it is likely that your e-mail address is used in an e-mail alias.
Only systems staff can enable spam deletion on e-mail aliases.
</p><p>However,
do note that spam scoring between 6 and your chosen threshold will still
be labelled and delivered as it always has been in the past. So you can
use this new service in addition to any filtering you already do yourself.
</p>
';

  $html .= $blurb;

  $html .= '<h2>Current settings for ' . $user . '</h2>';
 
  $html .= '<p>';
  $html .= '<form method="post" action="index.php">'; 
  $html .= '<input type="hidden" name="email" value="' . $user . '" />';

  $html .= '<input type="checkbox" name="enabled" value="1" ' . $enablechecked . '>Enable automatic spam deletion</input></p>';

  $html .= '<p>Spam threshold:<br/><br/>';

  foreach($selection as $key => $val)
  {
    $html .= '<input type="radio" name="spam_setting" value='
          . '"' . $key . '" ' . $selected[$key] . '>'
          . $val
          . '</input><br/>';
  }

  $html .= '<br/>We recommend you start with a setting of 7, and then lower it if you are still getting a lot of spam.<br/>';
  $html .= '<b>Please note</b>: There may be a delay of up to about an hour for any changes to take effect.<br/><br/>';
  $html .= '<input type="submit" name="sub" value="submit" /></form>';
  
  $html .= '</p>';

  return $html;
}


ECS_Page( 'Automatic spam deletion', $html );

ECS_CloseDB();

?>
